% Nos entra una imagen de un cierto tamao, para poder adaptar nuestro
% clasificador al HOG actual, dividiremos la imagen en bloques de sbin
% (8x8), una vez dividida la imagen completa en bloques hacemos las
% comparaciones que se hacian con la mediana de cada bloque

% De cada bloque sacaremos 16 descripciones, la comparacin con el bloque
% de su izquierda, su derecha, arriba, diagonal... AL igual que la
% comparacion con el bloque siguiente

% Entramos el hog porque windows
function desc = depthDesc(im, sbin)

    % No ignoro pxels, los aado al ltimo bloque
    
    if isunix()
        values = zeros(round(size(im,1)/sbin), round(size(im,2)/sbin));
    else %% ispc()
        values = zeros(winround(size(im,1)/sbin), winround(size(im,2)/sbin));
    end
    
    
    i = 1;
    for a = 1:size(values,1)
        j = 1;
        for b = 1:size(values,2)
            if a == size(values,1)
                if b == size(values,2)
                    patch = im(i:end, j:end,:);
                else
                    patch = im(i:end, j:j+7);
                end
            elseif b == size(values,2)
                patch = im(i:i+7, j:end);
            else
                patch = im(i:i+7,j:j+7);
            end
            values(a,b) = median(patch(:));
            j = j+8;
        end
        i = i+8;
    end
    
    % Una vez tenemos las medianas de todos los bloques, hacemos los
    % calculos de los bloques obviando los margenes (cuando se trata del
    % HOG, elimina un pxel por cada lado, nos guiaremos por ese modelo
    desc = zeros(size(values,1)-2, size(values,2)-2, 8*2);
    
    % Aadimos un padding para controlar las salidas de rango
    values = padarray(values,[1 1],0,'both');
    
    %{
        x       x       x
            x   x   x    
        x   x   o   x   x
            x   x   x   
        x       x       x
    %}

    
    
    a = 1;
    for i = 3:size(values,1)-2
        b = 1;
        for j = 3:size(values,2)-2
            
            desc(a,b,1)     = values(i-2,j-2)   > values(i,j); 
            desc(a,b,2)     = values(i-2,j)     > values(i,j);
            desc(a,b,3)     = values(i-2,j+2)   > values(i,j);
            desc(a,b,4)     = values(i-1,j-1)   > values(i,j);
            desc(a,b,5)     = values(i-1,j)     > values(i,j);
            desc(a,b,6)     = values(i-1,j+1)   > values(i,j);
            desc(a,b,7)     = values(i,j-2)     > values(i,j);
            desc(a,b,8)     = values(i,j-1)     > values(i,j);
            desc(a,b,9)     = values(i,j+1)     > values(i,j);
            desc(a,b,10)    = values(i,j+2)     > values(i,j);
            desc(a,b,11)    = values(i+1,j-1)   > values(i,j);
            desc(a,b,12)    = values(i+1,j)     > values(i,j);
            desc(a,b,13)    = values(i+1,j+1)   > values(i,j);
            desc(a,b,14)    = values(i+2,j-2)   > values(i,j);
            desc(a,b,15)    = values(i+2,j)     > values(i,j);
            desc(a,b,16)    = values(i+2,j+2)   > values(i,j);
            
            b = b +1;
        end
        a = a + 1;
    end
    
    
    end

    
function val = winround(num)
    if (num-floor(num) > 0.5)
        val = ceil(num);
    else
        val = floor(num);
    end
end
