function ap = calculateAP (fp, tp, npos, draw)

    fp = cumsum(fp);
    tp = cumsum(tp);
    rec = tp/npos;
    prec = tp./(fp+tp);

    ap = VOCap(rec,prec);

    if draw
        % plot precision/recall
        figure;
        plot(rec,prec,'-');axis([0 1 0 1]);
        grid;
        xlabel 'recall'
        ylabel 'precision'
        title(sprintf('AP = %.3f',ap));
    end
end


function ap = VOCap(rec,prec)
    mrec=[0 ; rec ; 1];
    mpre=[0 ; prec ; 0];
    for i=numel(mpre)-1:-1:1
        mpre(i)=max(mpre(i),mpre(i+1));
    end
    i=find(mrec(2:end)~=mrec(1:end-1))+1;
    ap=sum((mrec(i)-mrec(i-1)).*mpre(i));
end