%% Import libraries
addpath('./lib/classifiers/libsvm_primal/');
addpath('./lib/descriptors/');

tStart = tic;
load('uci_data/gauss.mat');

%% Parameters (to be changed for different tests)
str_test = 'HEAD'; p1 = 1; p2 = 2;        gaussian=gauss.head;
%str_test = 'R_HAND'; p1 = 7; p2 = 7;     gaussian=gauss.rhand;
%str_test = 'L_HAND'; p1 = 12; p2 = 12;   gaussian=gauss.lhand;

%descriptor = 1; str_desc = 'HOG';
%descriptor = 2; str_desc = 'DEPTH';
descriptor = 3; str_desc = 'HOG_DEPTH';

gaussian=imresize(gaussian,0.5);

%Image folders
folder{1} = 'DATA_DEPTH_V1/';   % testVideo = 1;
folder{2} = 'DATA_DEPTH_V2/';   % testVideo = 2;
folder{3} = 'DATA_DEPTH_V3/';   % testVideo = 3;
folder{4} = 'DATA_DEPTH_V4/';   % testVideo = 4;
folder{5} = 'DATA_DEPTH_V5/';   % testVideo = 5;
folder{6} = 'DATA_DEPTH_V6/';   % testVideo = 6;

data_path = './uci_data/';

path_to_save = ['./g_Results/', str_test, '/', str_desc, '/'];
path_to_load = ['./Results/', str_test, '/', str_desc, '/'];

if ~exist(path_to_save,'dir')
    mkdir(path_to_save);
end

global X    % For SVM

%for testVideo = 1:length(folder)
    testVideo = 2;
    iteration = 3;
    
    try 
        load([path_to_save 'TV_' num2str(testVideo) '_' str_test '_IT_' num2str(iteration) ]);
        fprintf('GAUSSIAN: %d - AP: %.3f\n', iteration, ap);
    catch
    
        path = [data_path folder{testVideo}];

        load([path_to_load 'TV_' num2str(testVideo) '_' str_test '_IT_' num2str(iteration)]);
        fprintf('IT: %d - AP: %.3f\n', iteration, ap);

        filename = [path_to_save 'TV_' num2str(testVideo) '_IT_' num2str(iteration) '.jpg'];
        [ap, boxes] = g_test (w,b,path,descriptor,p1,p2,filename,gaussian);

        fprintf('GAUSSIAN: %d - AP: %.3f\n', iteration, ap);
        save([path_to_save 'TV_' num2str(testVideo) '_' str_test '_IT_' num2str(iteration) ],'ap','boxes');
    end   
%end

time = toc(tStart);
fprintf('Time elapsed: %.3f h\n', time/3600);