function gauss = g_calculateGaussian(p,s)
    %Image folders
    folder{1} = 'DATA_DEPTH_V1/';   % testVideo = 1;
    folder{2} = 'DATA_DEPTH_V2/';   % testVideo = 2;
    folder{3} = 'DATA_DEPTH_V3/';   % testVideo = 3;
    folder{4} = 'DATA_DEPTH_V4/';   % testVideo = 4;
    folder{5} = 'DATA_DEPTH_V5/';   % testVideo = 5;
    folder{6} = 'DATA_DEPTH_V6/';   % testVideo = 6;

    data_path = './uci_data/';

    scale = 1;

    xval = [];
    yval = [];

    for video = 1:length(folder)

        path = [data_path folder{video}];
        images = dir([path '/*jpg']);
        xmid = zeros(1,length(images));
        ymid = zeros(1,length(images));

        for j = 1:length(images)

            fprintf('%s\n', [path, images(j).name]);

            points = load([path '' images(j).name(1:end-4) '_labels.mat']);

            % Positive
            xmid(1,j) = round(points.labels(p(2),1)/scale + ((points.labels(p(1),1)/scale - points.labels(p(2),1)/scale)/2));
            ymid(1,j) = round(points.labels(p(2),2)/scale + ((points.labels(p(1),2)/scale - points.labels(p(2),2)/scale)/2));

        end

        xval = [xval xmid];
        yval = [yval ymid];

    end

    img = imread([data_path folder{1} images(1).name]);
    img = imresize(img,scale);
    
    xmean = round(mean(xval));
    ymean = round(mean(yval));
    xstd = (round(std(xval)))^(s);
    ystd = (round(std(yval)))^(s);
    mu = [xmean ymean];
    Sigma = [xstd ystd];
    [X1,X2] = meshgrid(linspace(1,size(img,2),size(img,2))', linspace(1,size(img,1),size(img,1))');
    X = [X1(:) X2(:)];
    p = mvnpdf(X, mu, Sigma);
    gauss = reshape(p,size(img,1),size(img,2));
    gauss = (gauss)/max(max(gauss));
    
end