%% After the boostraping, we can see the obtained results
folder{1} = 'DATA_DEPTH_V1/';
folder{2} = 'DATA_DEPTH_V2/';
folder{3} = 'DATA_DEPTH_V3/';
folder{4} = 'DATA_DEPTH_V4/';
folder{5} = 'DATA_DEPTH_V5/';
folder{6} = 'DATA_DEPTH_V6/';

data_path = './uci_data/';

iteration = 3;
str_desc = 'HOG_DEPTH';
str_test_1 = 'HEAD';
str_test_2 = 'R_HAND';
str_test_3 = 'L_HAND';

path_1 = ['./g_Results/', str_test_1, '/', str_desc, '/'];
path_2 = ['./g_Results/', str_test_2, '/', str_desc, '/'];
path_3 = ['./g_Results/', str_test_3, '/', str_desc, '/'];

for testVideo = 1:length(folder),

    path_to_save = ['./g_Results/IMAGES/TV_' num2str(testVideo)];
    if ~exist(path_to_save,'dir')
        mkdir(path_to_save);
    end
    res = [path_to_save '/%.4d.jpg'];

    try
        head = load([path_1 'TV_' num2str(testVideo) '_' str_test_1 '_IT_' num2str(iteration)]);
        r_hand = load([path_2 'TV_' num2str(testVideo) '_' str_test_2 '_IT_' num2str(iteration)]);
        l_hand = load([path_3 'TV_' num2str(testVideo) '_' str_test_3 '_IT_' num2str(iteration)]);

        %fprintf('AP: \tHead: %.3f\tR.Hand: %.3f\tL.Hand: %.3f\n', head.ap,r_hand.ap,l_hand.ap);

        path = [data_path folder{testVideo}];
        images = dir([path '/*jpg']);

        % For each image
        for j=1:length(images)
            fprintf('\t(%d / %d)\n', j, length(images));
            imgT = imread([path, images(j).name]);
            imgT = imresize(imgT,0.5);    % Resize the img
            img(:,:,1) = imgT;
            img(:,:,2) = imgT;
            img(:,:,3) = imgT;
            %showboxes(img,head.boxes(j,1:4), {'b'});
            showboxes(img,[head.boxes(j,1:4);r_hand.boxes(j,1:4);l_hand.boxes(j,1:4)], {'b','r','g'});
            print(sprintf(res,j),'-djpeg');
            pause(.05);

        end
    catch
        %error('File %s not found !\n', name);
    end
end