function [ap, det_boxes] = g_test (w,b,path,descriptor,p1,p2,filename, gaussian) 
 
    sbin = 8;
    if descriptor == 1
        dim = (6*7*32);
    elseif descriptor == 2
        dim = (6*7*16);
    else
        dim = (6*7*32)+(6*7*16);
    end

    images = dir([path '/*jpg']);

    %% Init variables
    box_widht = 70;
    box_height = 60;

    npos = length(images);
    ids = []; 
    detections = [];
    det_boxes = zeros(npos, 5);

    bbgt = zeros(npos, 4);  % True boxes

    %% For each image
    for j=1:npos
        imgT = imread([path, images(j).name]);
        imgT = imresize(imgT,0.5);    % Resize the img
        img(:,:,1) = imgT;
        img(:,:,2) = imgT;
        img(:,:,3) = imgT;

        points = load([path '' images(j).name(1:end-4) '_labels.mat']);

        %fprintf('(%d / %d) \n', j, npos);
        fprintf('.');
        
        % True head box
        auxbbgt = getBoxPartBody(points.labels(:,1),points.labels(:,2), box_widht/2, box_height/2,p1,p2);
        bbgt(j,:) = auxbbgt;
            
        [m n z] = size(img);

        step = 8;

        desc = zeros(length(1:step:m-60)*length(1:step:n-70),dim);
        boxes = zeros(length(1:step:m-60)*length(1:step:n-70),4);

        % Sliding window
        cont=1;
        for y=1:step:m-(box_height),
            for x=1:step:n-(box_widht),
                % Box to compare
                aux = img(y:y+box_height,x:x+box_widht,:);
                boxes(cont,:) = [ x y x+box_widht y+box_height ];
                if descriptor == 1
                    feat = features(double(aux),sbin);
                    desc(cont,:) = feat(:)';
                elseif descriptor == 2
                    depth = depthDesc(double(aux),sbin);
                    desc(cont,:) = depth(:)';
                else
                    feat = features(double(aux),sbin);
                    depth = depthDesc(double(aux),sbin);
                    desc(cont,:) = [feat(:)' depth(:)'];
                end
                cont=cont+1; 
               
            end
        end

        score=sum(repmat(w,1, size(desc,1)) .* desc') +b;
        
        %[predicted_label, accuracy, decision_values] = svmpredict(ones(size(desc,1),1), desc, model,'-b 1');
        
        minScore = 0;
        posboxes = find(score(1,:) > minScore); %
        tmpDetections = [boxes(posboxes,:) (score(posboxes)+abs(minScore))'];
        pick = nms(boxes(posboxes,:), 0.5);                     % Overlap boxes 50%
        detections = [detections; tmpDetections(pick,:)];       %
        ids = [ids; j*ones(size(pick,1),1)];                    %
        
    end
    
    
    % We apply the gaussian distr
    xmid = round(detections(:,3) + ((detections(:,1) - detections(:,3))/2));
    ymid = round(detections(:,4) + ((detections(:,2) - detections(:,4))/2));
    pmid = [ymid xmid];
    for i = 1:size(pmid,1)
        detections(i,5) = detections(i,5)*(gaussian(pmid(i,1),pmid(i,2)));
    end
        
    

    minoverlap = 0.5;     % hihger than 0.5 is a TP

    [v pos] = sort(detections(:,end),'descend');

    ids = ids(pos);
    detections = detections(pos,:);

    tp = zeros(size(detections,1),1);
    fp = zeros(size(detections,1),1);
    alreadyDetected = zeros(max(ids),1);

    for i=1:size(detections,1)
        
        bb = detections(i,:);       % Bounding Box

        % We save for each image the considered best detection
        if (max(det_boxes(ids(i),:)) == 0)
            det_boxes(ids(i),:) = bb;
        end
        
        bi = [max(bb(1),bbgt(ids(i),1)) ; max(bb(2),bbgt(ids(i),2)) ; min(bb(3),bbgt(ids(i),3)) ; min(bb(4),bbgt(ids(i),4))];
        iw = bi(3)-bi(1)+1;
        ih = bi(4)-bi(2)+1;

        % compute overlap as area of intersection / area of union
        ua = (bb(3)-bb(1)+1)*(bb(4)-bb(2)+1)+...
            (bbgt(ids(i),3)-bbgt(ids(i),1)+1)*(bbgt(ids(i),4)-bbgt(ids(i),2)+1)-...
            iw*ih;
        ov = iw*ih/ua;

        if ov >= minoverlap
            if(alreadyDetected(ids(i))==0)
                tp(i) = 1;            % true positive
                alreadyDetected(ids(i)) = 1;
            else
                fp(i) = 1;              % false positive
            end
        else
            fp(i) = 1;                  % false positive
        end
    end
    
    fprintf('\n');
    ap = calculateAP(fp, tp, npos, true);
    print(filename,'-djpeg');
    close; pause(0.02);

end