function XNegtraining = train_addHardNegatives (im_path, folder, testVideo, w,b, XNegtraining, p1,p2,descriptor)

    %% Parameters
    box_widht = 70;
    box_height = 60;

    sbin = 8;  % For descriptor
    if descriptor == 1
        dim = (6*7*32);
    elseif descriptor == 2
        dim = (6*7*16);
    else
        dim = (6*7*32)+(6*7*16);
    end

    addNegatives = 5000;

    numOldSamples=size(XNegtraining,1);
    XNegtraining(end+1:end+addNegatives,1:end)=0;
    % Ara hem d'afegir tants hard negatives com (addNegatives) al vector de training
    % Afegirem hard negatives, els que donin positiu i no ho siguin

    images=[];
    contIm=1;
    for i=setdiff(1:6,testVideo)
        path = [im_path folder{i}];
        imagesDir = dir([path '/*jpg']);
        for j=1:size(imagesDir)
            images(contIm).name=imagesDir(j).name;
            images(contIm).path=path;
            contIm=contIm+1;
        end
    end

    ind = randperm(length(images));
    contador = 0;
    contImatge = 1;
    while (contador < addNegatives && contImatge < length(images))

        % Init variables
        detections = [];
        cont2=1;

        im = ind(contImatge);
        contImatge = contImatge+1;
        imgT = imread([images(im).path, images(im).name]);
        points = load([images(im).path '' images(im).name(1:end-4) '_labels.mat']);

        imgT = imresize(imgT,0.5);    % Resize the img
        img(:,:,1) = imgT;
        img(:,:,2) = imgT;
        img(:,:,3) = imgT;

        %% True head box
        bbgt = getBoxPartBody(points.labels(:,1),points.labels(:,2), box_widht/2, box_height/2,p1,p2);
        
        [m n z] = size(img);

        step = 8;

        desc = zeros(length(1:step:m-60)*length(1:step:n-70),dim);
        boxes = zeros(length(1:step:m-60)*length(1:step:n-70),4);

        % Sliding window
        cont=1;
        for y=1:step:m-(box_height),
            for x=1:step:n-(box_widht),
                % Box to compare
                aux = img(y:y+box_height,x:x+box_widht,:);
                boxes(cont,:) = [ x y x+box_widht y+box_height ];
                if descriptor == 1
                    feat = features(double(aux),sbin);
                    desc(cont,:) = feat(:)';
                elseif descriptor == 2
                    depth = depthDesc(double(aux),sbin);
                    desc(cont,:) = depth(:)';
                else
                    feat = features(double(aux),sbin);
                    depth = depthDesc(double(aux),sbin);
                    desc(cont,:) = [feat(:)' depth(:)'];
                end
                cont=cont+1;
            end
        end

        score=sum(repmat(w,1, size(desc,1)) .* desc') +b;
        
        %[predicted_label, accuracy, decision_values] = svmpredict(ones(size(desc,1),1), desc, model);
        posboxes = find(score(1,:) > 0); % 0 ???
        
        tmpDetections = [boxes(posboxes,:) score(posboxes)'];
        pick = nms(boxes(posboxes,:), 0.5);                     % Overlap boxes 50%
        tmpDetections = tmpDetections(pick,:);
        
        [v pos] = sort(tmpDetections(:,end),'descend');
        tmpDetections=tmpDetections(pos(1:min(length(pos),10)),:);
        detections(cont2:cont2+size(tmpDetections,1)-1,:) = tmpDetections;   %
        cont2=cont2+size(tmpDetections,1);
        
        detections = detections(1:cont2-1,:);

        %%
        minoverlap = 0.5;     % hihger than 0.5 is a TP

        %%
        if(~isempty(detections))
            [v pos] = sort(detections(:,end),'descend');

            %ids = ids(pos);
            detections = detections(pos,:);
            for i=1:size(detections,1)

                bb = detections(i,:);       % Bounding Box

                bi = [max(bb(1),bbgt(1,1)) ; max(bb(2),bbgt(1,2)) ; min(bb(3),bbgt(1,3)) ; min(bb(4),bbgt(1,4))];
                iw = bi(3)-bi(1)+1;
                ih = bi(4)-bi(2)+1;

                % compute overlap as area of intersection / area of union
                ua = (bb(3)-bb(1)+1)*(bb(4)-bb(2)+1)+...
                    (bbgt(1,3)-bbgt(1,1)+1)*(bbgt(1,4)-bbgt(1,2)+1)-...
                    iw*ih;
                ov = iw*ih/ua;
                
                if ov < minoverlap
                    % TO HARD NEGATIVE
                    contador = contador+1;
                    aux = img(bb(2):bb(4),bb(1):bb(3),:);
                    if descriptor == 1
                        feat = features(double(aux),sbin);
                        desc = feat(:)';
                    elseif descriptor == 2
                        depth = depthDesc(double(aux),sbin);
                        desc = depth(:)';
                    else
                        feat = features(double(aux),sbin);
                        depth = depthDesc(double(aux),sbin);
                        desc = [feat(:)' depth(:)'];
                    end
                    XNegtraining(contador+numOldSamples,:) = desc(:);
                    %XNegtraining = [XNegtraining; feat(:)'];
                    if (contador == addNegatives)
                        break;
                    end

                end
            end
        end
        
        fprintf('(%d / %d) - (%d / %d) - %s\n', contImatge, length(images), contador, addNegatives, [images(im).path, images(im).name]);
        
    end
    
    XNegtraining((contador+1)+numOldSamples:end,:) = [];

end