%% Returns a box with less than 50% in comun with the parameter region
function coord = train_boxOutOfRange (xOrig, yOrig, width, height)
    ImageWidth = 640/2;
    ImageHeigh = 480/2;

    xrand = randi(ImageWidth - width,1,1);
    yrand = randi(ImageHeigh - height,1,1); 
    
    while (comunPixels(xOrig,yOrig,xrand,yrand,width,height) >= (width*height/2))
        xrand = randi(ImageWidth-width,1,1);
        yrand = randi(ImageHeigh-height,1,1);
    end
    
    coord = [xrand yrand xrand+width yrand+height];
end

%% Returns the number of pixels in comun
function num = comunPixels(x1,y1,x2,y2,a,h)
    if (abs(x1-x2) > a) || (abs(y1-y2) > h), 
        num = 0;
        return;
    end
    
    % If x1 is in the left (than x2)
    if (x1-x2 >= 0),
        xComun = (x2+a)-x1;
    else,
        xComun = (x1+a)-x2;
    end
    
    % If y1 is in the right (than y2)
    if (y1-y2 < 0),
        yComun = (y1+h)-y2;
    else,
        yComun = (y2+h)-y1;
    end
    
    num = xComun*yComun;

end