% Load initial training 
function [XPostraining XNegtraining] = train_trainingData (data_path, testVideo, part, p1, p2, descriptor, str_desc)

    try
        fprintf('Loading Training Data [%s]...\n', [data_path part str_desc '.mat']);
        load([data_path part str_desc]);
    catch
        data = train_doTrain(data_path, p1, p2, [part str_desc], descriptor);
    end
    
    XPostraining = [];
    XNegtraining = [];

    for i = setdiff(1:6, testVideo)
        fprintf('\tLoading Training Data... (%d)\n',i);
        XPostraining = [XPostraining; data{i}.xPos];
        XNegtraining = [XNegtraining; data{i}.xNeg];
    end

    ind = randperm(size(XNegtraining,1));
    % Take the same number of negatives than positives
    ind = ind(1:size(XPostraining,1));
    XNegtraining = XNegtraining(ind,:);

end